/*! \file *********************************************************************
 *
 * \brief DB101 ؂g߂̗: "DB101ɑ΂鎄̍ŏ̉p"
 *
 *		̧قDB101p̺ ײ؂gĺޏn߂邽߂̗
 *
 * \par pLq:
 *      AVR483: DB101̧ѳ - Jnɍۂ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision: 2492 $
 * $URL: http://svn.norway.atmel.com/AppsAVR8/avr483_db101_firmware_getting_started/branches/20070921_release/code/main.c $
 * $Date: 2007N921 14:47:36 +0200 (fr, 21 sep 2007) $  \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *****************************************************************************/

#include "lcd_lib.h"
#include "gfx_lib.h"
#include "joystick_driver.h"
#include "timing_lib.h"
#include "rtc_driver.h"
#include "backlight_driver.h"
#include "common.h"

#include <ioavr.h>
#include <inavr.h>

//! ޮè ײނɂĎgݸގ
TIMING_event_t joystickCallbackEvent;

//! ŏ̎֐l^錾
void moving_lines_demo( void );

void main( void )
{
	/* --- KvƂPʕ --- */

	// LCD摜
	LCD_Init();
	// wʏƖײ
	BACKLIGHT_Init();
	// Ⴆ΁Aޮè ײނɕKvƂݸ ײ
	TIMING_Init();
	// LpȊԂ񋟂Ըۯ
	RTC_Init();
	// ޮè ײށB100̉ێx50 دx
	JOYSTICK_Init( 100, 50 );

	// ݸ ײ؂Ըۯɐڑ
	RTC_SetTickHandler( TIMING_TickHandler );
	// ޮè ߰ݸނ߂ɒݸގۂݒ
	TIMING_AddRepCallbackEvent( TIMING_INFINITE_REPEAT, 1,
								JOYSTICK_PollingHandler,
								&joystickCallbackEvent );

	// @\Jn
	__enable_interrupt();

	/* --- Ay݂܂傤B --- */

	// 𖳌ɑs
	for (;;) {
		moving_lines_demo();
	}
}

void moving_lines_demo( void )
{
	// ʂ̒ŊJn
	uint8_t x1 = LCD_WIDTH / 2;
	uint8_t y1 = LCD_HEIGHT / 2;
	uint8_t x2 = LCD_WIDTH / 2;
	uint8_t y2 = LCD_HEIGHT / 2;

	// ޮèENTERɂ"done"^ɐݒ肳܂ŌJԂ
	bool done = false;
	while (done == false) {
		// `
		LCD_SetLine( x1, y1, x2, y2 );

		// x点邽߂1/10b҂
		TIMING_WaitFor( RTC_TICKS_PER_SECOND / 10 );

		// ޮè҂
		do { /*  */ } while (JOYSTICK_GetState() == 0);

		// Â
		LCD_ClrLine( x1, y1, x2, y2 );

		// UP/DOWN
		if (JOYSTICK_IsUpPressed()) {
			--y1;
			++y2;
		}
		else if (JOYSTICK_IsDownPressed()) {
			++y1;
			--y2;
		}

		// LEFT/RIGHT
		if (JOYSTICK_IsLeftPressed()) {
			--x1;
			++x2;
		}
		else if (JOYSTICK_IsRightPressed()) {
			++x1;
			--x2;
		}

		// ENTER
		if (JOYSTICK_IsEnterPressed()) {
			done = true;
		}
	}
}

// ̧ق̍Ō
